<template>
  <div class="input-group">
    <input
      ref="refInputMask"
      v-imask="mask"
      :value="getValue[0]"
      class="form-control form-control-flush queryfactory-condition-input w-100 h-100 rounded-0"
      :disabled="disabled"
      placeholder="Min value"
      :max="getValue[1]"
      @change="updateMin"
    />
    <input
      ref="refInputMask"
      v-imask="mask"
      :value="getValue[1]"
      class="form-control form-control-flush queryfactory-condition-input w-100 h-100 rounded-0"
      :disabled="disabled"
      placeholder="Max value"
      :min="getValue[0]"
      @change="updateMax"
    />
  </div>
</template>

<script>
import { IMaskDirective } from 'vue-imask';
export default {
  directives: {
    imask: IMaskDirective,
  },
  props: {
    value: {
      type: String,
      default: '',
      required: true,
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    rule: {
      type: Object,
      default: () => {},
    },
    ruleProperties: {
      type: Object,
      default: () => {},
    },
    customMask: {
      type: Function,
      required: true,
      default: () => ({}),
    },
  },
  data() {
    return {
      minValue: null,
      maxValue: null,
      mask: null,
    };
  },
  computed: {
    getValue() {
      return this.value.split(',');
    },
  },
  created() {
    this.mask = this.customMask();
  },
  beforeMount() {
    this.minValue =
      this.inputType === 'number'
        ? parseInt(this.getValue[0])
        : this.getValue[0];
    this.maxValue =
      this.inputType === 'number'
        ? parseInt(this.getValue[1])
        : this.getValue[1];
    if (
      !this.isValidNumber(this.minValue) ||
      !this.isValidNumber(this.maxValue) ||
      this.minValue > this.maxValue
    ) {
      this.setIsDataCompleted(false);
    }
  },
  methods: {
    getParsedValue() {
      let isAccepted = true;
      // number
      if (this.inputType === 'number') {
        const minNumericValue = parseFloat(this.minValue);
        const maxNumericValue = parseFloat(this.maxValue);
        if (isNaN(minNumericValue) || isNaN(maxNumericValue)) {
          isAccepted = false;
        }
      }
      const newValue = `${this.minValue},${this.maxValue}`;
      return { data: newValue, isAccepted };
    },
    emitParsedValue(isDataCompleted = true) {
      if (this.disabled) return;
      const parsedValue = this.getParsedValue();
      this.setIsDataCompleted(isDataCompleted && parsedValue.isAccepted);
      this.$emit('input', parsedValue.data);
    },
    updateMin(e) {
      this.minValue =
        this.inputType === 'number' ? parseInt(e.target.value) : e.target.value;
      this.updateValue();
    },
    updateMax(e) {
      this.maxValue =
        this.inputType === 'number' ? parseInt(e.target.value) : e.target.value;
      this.updateValue();
    },
    updateValue() {
      if (
        this.isValidNumber(this.minValue) &&
        this.isValidNumber(this.maxValue) &&
        this.minValue <= this.maxValue
      ) {
        this.emitParsedValue(true);
        this.$emit('inputCompleted', this.rule);
      }
      this.setIsDataCompleted(false);
    },
    isValidNumber(value) {
      return value !== null && value !== '' && value !== undefined;
    },
    setIsDataCompleted(isValid) {
      this.$set(this.rule, 'isDataCompleted', isValid);
    },
  },
};
</script>
